#ifndef GLOBAL_H
#define GLOBAL_H

#include "Export.h"

#define V_DISABLE_COPY(Class) \
    Class(const Class &); \
    Class &operator=(const Class &);

template <typename T> static inline T *vGetPtrHelper(T *ptr) { return ptr; }
template <typename Wrapper> static inline typename Wrapper::pointer vGetPtrHelper(const Wrapper &p) { return p.data(); }

#define V_DECLARE_PRIVATE(Class) \
    inline Class##Private* d_func() { return reinterpret_cast<Class##Private *>(vGetPtrHelper(d_ptr)); } \
    inline const Class##Private* d_func() const { return reinterpret_cast<const Class##Private *>(vGetPtrHelper(d_ptr)); } \
    friend class Class##Private;

#define V_DECLARE_PUBLIC(Class)                                    \
    inline Class* q_func() { return static_cast<Class *>(q_ptr); } \
    inline const Class* q_func() const { return static_cast<const Class *>(q_ptr); } \
    friend class Class;

#define V_D(Class) Class##Private * const d = d_func()
#define V_Q(Class) Class * const q = q_func()

#endif // GLOBAL_H
